Attribute VB_Name = "modLZW"
Option Explicit
'
' Module de compression/dcompression (Mthode LZW)
' 21/02/1999 [ Pied-vif ]
'

' Taille des mots  lire
Public BITCHAR As Long
' Taille des mots du dictionnaire
Public BITIND As Long
' Taille d'un long en binaire
Private Const LONGMOT = 32
Private lgDicoMin As Long
Private lgMaxDico As Long

' Taille du dictionnaire courant. Sa taille ne doit
' pas dpasser 2^BITIND
Private lgDictionnaire As Long
' Dictionnaire de compression/dcompression
Private Dictionnaire() As String

' Handle du fichier  (d)compresser
Private inFIn As Integer
' Handle du fichier rsultat
Private inFOut As Integer

' Longueur du fichier source
Private lgLenF As Long
' Nombre d'lments lus
Private lgNbLu As Long
' Nombre d'lments crits
Private lgNbEc
' Variable pour boucle For...Next
Private lgFor As Long

' Buffer de lecture
Private stReadBuffer As String
' Buffer d'criture
Private stWriteBuffer As String
Private Sub CreationDico()
' Cration du dictionnaire de base pour la compression/dcompression
lgDicoMin = (2 ^ BITCHAR) - 1
lgDictionnaire = (2 ^ BITCHAR) - 1
ReDim Dictionnaire(lgDictionnaire) As String
For lgFor = 0 To lgDictionnaire
    Dictionnaire(lgFor) = DecToBin(lgFor, BITCHAR)
Next lgFor
lgMaxDico = 2 ^ BITIND
ReDim Preserve Dictionnaire(lgMaxDico - 1) As String
End Sub
Public Function DecToBin(lgNbDec As Long, lgBase As Long) As String
' Transforme un dcimal en binaire
' La fonction complte avec des 0 (ou des 1 si ngatif) en fonction de BITCHAR
' Retourne le rsultat sous forme de chane
Dim stResultat As String
Dim lgDec As Long, lgK As Long
If lgNbDec < 0 Then lgK = 1
lgDec = Abs(lgNbDec)
Do While lgDec <> 0
    stResultat = (lgDec + lgK) Mod 2 & stResultat
' Divisions successives par 2, pour obtenir le nombre binaire
    lgDec = lgDec \ 2
Loop
DecToBin = Right$(String$(lgBase, CStr(lgK)) & stResultat, lgBase)
End Function

Public Function BinToDec(stNbBin As String) As Long
' Transforme un binaire en dcimal
Dim lgLen As Long
Dim dlResultat As Double, lgDeux As Double
Dim stTmp As String
lgLen = Len(stNbBin)
stTmp = StrReverse(stNbBin)
lgDeux = 1
For lgFor = 1 To lgLen
    dlResultat = dlResultat + CLng(Mid$(stTmp, lgFor, 1)) * lgDeux
    lgDeux = lgDeux * 2
Next lgFor
If dlResultat > 2147483647 Then
    BinToDec = dlResultat - 4294967295#
Else
    BinToDec = dlResultat
End If
End Function
Private Function InDico(stString As String) As Long
' Regarde si la chane 'stString' se trouve dans le dictionnaire
' Retourne sa position si la chane est trouve, sinon -1
Dim lgDeb As Long
If Len(stString) > BITCHAR Then lgDeb = lgDicoMin
For lgFor = lgDeb To lgDictionnaire
    If Dictionnaire(lgFor) = stString Then
        InDico = lgFor
        Exit Function
    End If
Next lgFor
InDico = -1
End Function
Public Sub Start(blCompress As Boolean, stFileIn As String, stFileOut As String)
Dim lgTmp As Long
' Cration du dictionnaire
Call CreationDico

' Initialisation des variables d'avancement
lgLenF = FileLen(stFileIn)
lgNbLu = 0
lgNbEc = 0

inFIn = FreeFile
' Ouverture du fichier d'entre
Open stFileIn For Random Access Read As inFIn Len = Len(lgTmp)
inFOut = FreeFile
' Ouverture du fichier rsultat
Open stFileOut For Random Access Write As inFOut Len = Len(lgTmp)

' Initialisation des buffers de lecture et criture
stReadBuffer = vbNullString
stWriteBuffer = vbNullString

If blCompress Then
' Appel de la procdure de compression
    Call LZW
Else
' Appel de la procdure de dcompression
    Call DeLZW
End If

' Fermeture des fichiers
Close inFIn
Close inFOut



End Sub
Public Function LireBIT(lgBase As Long) As String
' Lit le prochain lment de longueur 'lgBase' dans le fichier d'entre
Dim lgTmp As Long
Dim stResultat As String

Do While Len(stReadBuffer) < 200000 And Not EOF(inFIn)
    Get inFIn, , lgTmp

' Un long fait 4 octets (donc lgNbLu + 4)
    lgNbLu = lgNbLu + 4
    frmLZW.lblInfo1.Caption = "Lu : " & lgNbLu & " / " & lgLenF
    DoEvents

' Augmente le buffer de lecture avec l'lment qui vient d'tre lu
    stReadBuffer = DecToBin(lgTmp, LONGMOT) & stReadBuffer
Loop
stResultat = Right$(stReadBuffer, lgBase)
' ici plantage quand streadbuffer < lgbase !!
If Len(stReadBuffer) - lgBase < 0 Then
    stReadBuffer = vbNullString
Else
    stReadBuffer = Left$(stReadBuffer, Len(stReadBuffer) - lgBase)
End If
LireBIT = stResultat
End Function
Public Sub EcrireBIT(stBitIndice As String)
' Ecrit l'lment 'Indice' du dictionnaire sous la base 'lgBase' dans le fichier de rsultat de la compression
Dim lgTmp As Long
Dim lgFor As Long
' Augmente le buffer d'criture avec la chane stBitIndice
stWriteBuffer = stBitIndice & stWriteBuffer
' Ds que la chane fait au moins 32 caractre (la taille d'un binaire long)
' on en convertit un morceau pour l'ajouter au fichier rsultat
Do While Len(stWriteBuffer) >= LONGMOT
' Conversion Binaire vers Long
    lgTmp = BinToDec(Right$(stWriteBuffer, LONGMOT))
' Ecriture dans le fichier
    Put inFOut, , lgTmp
    
' Un long fait 4 octets (donc lgNbEc + 4)
    lgNbEc = lgNbEc + 4
    frmLZW.lblInfo2.Caption = "Ecrit : " & lgNbEc

' On diminue la buffer d'criture, de la chane qu'on vient d'ajouter
    stWriteBuffer = Left$(stWriteBuffer, Len(stWriteBuffer) - LONGMOT)
Loop
End Sub
Public Sub LZW()
' Procdure principale de compression
Dim lgChaine As Long
Dim stCourant As String
Dim stCarTmp As String
stCourant = LireBIT(BITCHAR)
Do While Not EOF(inFIn) Or stReadBuffer <> vbNullString
    stCarTmp = LireBIT(BITCHAR)
    If InDico(stCarTmp + stCourant) > -1 Then
        stCourant = stCarTmp + stCourant
    Else
        Call EcrireBIT(DecToBin(InDico(stCourant), BITIND))
' Augmente le dictionnaire
        lgDictionnaire = lgDictionnaire + 1
        If lgDictionnaire Mod 100 = 0 Then frmLZW.lblInfo3.Caption = "Taille Dictionnaire : " & lgDictionnaire & " (" & lgMaxDico & ")"
        Dictionnaire(lgDictionnaire) = stCarTmp + stCourant
        stCourant = stCarTmp
        DoEvents
    End If
Loop
Call EcrireBIT(DecToBin(InDico(stCourant), BITIND))
' Ecriture du bout de chane restant
If stWriteBuffer <> vbNullString Then     ' Taille d'un lment de type long
    lgChaine = BinToDec(Right$(stWriteBuffer, LONGMOT))
    Put inFOut, , lgChaine
End If
End Sub
Public Function DeLZW()
' Procdure de dcompression
Dim stCode As String
Dim lgAvance As Long
Dim stOld As String
Dim lgCourant As Long
Dim stCarTmp As String
Dim stCourant As String
' Initialisation de la lecture
stCode = LireBIT(BITIND)
Call EcrireBIT(Dictionnaire(BinToDec(stCode)))
stOld = stCode
Do While Not EOF(inFIn) Or stReadBuffer <> vbNullString
    stCode = LireBIT(BITIND)
    stCourant = Dictionnaire(BinToDec(stOld))
    If BinToDec(stCode) <= lgDictionnaire Then
        stCarTmp = Right$(Dictionnaire(BinToDec(stCode)), BITCHAR)
    Else
        stCarTmp = Right$(stCourant, BITCHAR)
    End If
' Augmente le dictionnaire
    lgDictionnaire = lgDictionnaire + 1
    If lgDictionnaire Mod 100 = 0 Then frmLZW.lblInfo3.Caption = "Taille Dictionnaire : " & lgDictionnaire & " (" & lgMaxDico & ")"
    Dictionnaire(lgDictionnaire) = stCarTmp + stCourant
    Call EcrireBIT(Dictionnaire(BinToDec(stCode)))
    stOld = stCode
    DoEvents
Loop
End Function
